"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableContent = void 0;
var tslib_1 = require("tslib");
var react_1 = (0, tslib_1.__importDefault)(require("react"));
var TableBody_1 = require("./TableBody");
var mobx_react_1 = require("mobx-react");
var ItemActionsWrapper_1 = (0, tslib_1.__importDefault)(require("./ItemActionsWrapper"));
var icon_1 = require("../../utils/icon");
var icons_1 = require("../../components/icons");
var TableContent = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(TableContent, _super);
    function TableContent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TableContent.prototype.renderItemActions = function () {
        var _a = this.props, itemActions = _a.itemActions, render = _a.render, store = _a.store, cx = _a.classnames;
        var finalActions = Array.isArray(itemActions)
            ? itemActions.filter(function (action) { return !action.hiddenOnHover; })
            : [];
        if (!finalActions.length) {
            return null;
        }
        return (react_1.default.createElement(ItemActionsWrapper_1.default, { store: store, classnames: cx },
            react_1.default.createElement("div", { className: cx('Table-itemActions') }, finalActions.map(function (action, index) {
                return render("itemAction/".concat(index), (0, tslib_1.__assign)((0, tslib_1.__assign)({}, action), { isMenuItem: true }), {
                    key: index,
                    item: store.hoverRow,
                    data: store.hoverRow.locals,
                    rowIndex: store.hoverRow.index
                });
            }))));
    };
    TableContent.prototype.render = function () {
        var _a, _b;
        var _c = this.props, placeholder = _c.placeholder, cx = _c.classnames, render = _c.render, className = _c.className, columns = _c.columns, columnsGroup = _c.columnsGroup, onMouseMove = _c.onMouseMove, onScroll = _c.onScroll, tableRef = _c.tableRef, rows = _c.rows, renderHeadCell = _c.renderHeadCell, renderCell = _c.renderCell, onCheck = _c.onCheck, rowClassName = _c.rowClassName, onQuickChange = _c.onQuickChange, footable = _c.footable, footableColumns = _c.footableColumns, checkOnItemClick = _c.checkOnItemClick, buildItemProps = _c.buildItemProps, onAction = _c.onAction, rowClassNameExpr = _c.rowClassNameExpr, affixRowClassName = _c.affixRowClassName, prefixRowClassName = _c.prefixRowClassName, data = _c.data, prefixRow = _c.prefixRow, locale = _c.locale, translate = _c.translate, itemAction = _c.itemAction, affixRow = _c.affixRow, store = _c.store, emptyIcon = _c.emptyIcon, dispatchEvent = _c.dispatchEvent, onEvent = _c.onEvent;
        var tableClassName = cx('Table-table', this.props.tableClassName);
        var hideHeader = columns.every(function (column) { return !column.label; });
        var iconElement = null;
        if (emptyIcon) {
            iconElement =
                typeof emptyIcon === 'string'
                    ? (0, icon_1.generateIcon)(cx, emptyIcon, 'Icon')
                    : render('icon', emptyIcon);
        }
        return (react_1.default.createElement("div", { onMouseMove: onMouseMove, className: cx('Table-content', className), onScroll: onScroll },
            store.hoverRow ? this.renderItemActions() : null,
            react_1.default.createElement("table", { ref: tableRef, className: tableClassName },
                react_1.default.createElement("thead", null,
                    columnsGroup.length ? (react_1.default.createElement("tr", null, columnsGroup.map(function (item, index) { return (react_1.default.createElement("th", { key: index, "data-index": item.index, colSpan: item.colSpan, rowSpan: item.rowSpan }, item.label ? render('tpl', item.label) : null)); }))) : null,
                    react_1.default.createElement("tr", { className: hideHeader ? 'fake-hide' : '' }, columns.map(function (column) {
                        var _a;
                        return ((_a = columnsGroup.find(function (group) { return ~group.has.indexOf(column); })) === null || _a === void 0 ? void 0 : _a.rowSpan) === 2
                            ? null
                            : renderHeadCell(column, {
                                'data-index': column.index,
                                'key': column.index
                            });
                    }))),
                !rows.length ? (react_1.default.createElement("tbody", null,
                    react_1.default.createElement("tr", { className: cx('Table-placeholder') },
                        react_1.default.createElement("td", { colSpan: columns.length },
                            iconElement ? (react_1.default.cloneElement(iconElement, {
                                className: cx((_b = (_a = iconElement === null || iconElement === void 0 ? void 0 : iconElement.props) === null || _a === void 0 ? void 0 : _a.className) !== null && _b !== void 0 ? _b : '', 'Table-placeholder-empty-icon', 'icon')
                            })) : (react_1.default.createElement(icons_1.Icon, { icon: "desk-empty", className: cx('Table-placeholder-empty-icon', 'icon') })),
                            render('placeholder', translate(placeholder || 'placeholder.noData')))))) : (react_1.default.createElement(TableBody_1.TableBody, { itemAction: itemAction, classnames: cx, render: render, renderCell: renderCell, onCheck: onCheck, onQuickChange: onQuickChange, footable: footable, footableColumns: footableColumns, checkOnItemClick: checkOnItemClick, buildItemProps: buildItemProps, onAction: onAction, rowClassNameExpr: rowClassNameExpr, rowClassName: rowClassName, prefixRowClassName: prefixRowClassName, affixRowClassName: affixRowClassName, rows: rows, columns: columns, locale: locale, translate: translate, prefixRow: prefixRow, affixRow: affixRow, data: data, rowsProps: {
                        data: data,
                        dispatchEvent: dispatchEvent,
                        onEvent: onEvent
                    } })))));
    };
    TableContent = (0, tslib_1.__decorate)([
        mobx_react_1.observer
    ], TableContent);
    return TableContent;
}(react_1.default.Component));
exports.TableContent = TableContent;
//# sourceMappingURL=./renderers/Table/TableContent.js.map
